<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>Markmap</title>
<style>
* {
  margin: 0;
  padding: 0;
}
#mindmap {
  display: block;
  width: 100vw;
  height: 100vh;
}
</style>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/markmap-toolbar@0.14.3/dist/style.css">
</head>
<body>
<svg id="mindmap"></svg>
<script src="https://cdn.jsdelivr.net/npm/d3@6.7.0"></script><script src="https://cdn.jsdelivr.net/npm/markmap-view@0.14.3"></script><script src="https://cdn.jsdelivr.net/npm/markmap-toolbar@0.14.3/dist/index.umd.min.js"></script><script>(r => {
                setTimeout(r);
              })(() => {
  const {
    markmap,
    mm
  } = window;
  const toolbar = new markmap.Toolbar();
  toolbar.attach(mm);
  const el = toolbar.render();
  el.setAttribute('style', 'position:absolute;bottom:20px;right:20px');
  document.body.append(el);
})</script><script>((getMarkmap, getOptions, root, jsonOptions) => {
        const markmap = getMarkmap();
        window.mm = markmap.Markmap.create('svg#mindmap', (getOptions || markmap.deriveOptions)(jsonOptions), root);
      })(() => window.markmap,null,{"type":"heading","depth":0,"payload":{"lines":[0,1]},"content":"configuration","children":[{"type":"heading","depth":1,"payload":{"lines":[2,3]},"content":"config file and properties","children":[{"type":"heading","depth":2,"payload":{"lines":[4,5]},"content":"config file","children":[{"type":"heading","depth":3,"payload":{"lines":[6,7]},"content":"global config file","children":[{"type":"list_item","depth":4,"payload":{"lines":[8,9],"index":1},"content":"1. location"},{"type":"list_item","depth":4,"payload":{"lines":[9,10],"index":2},"content":"2. format","children":[{"type":"list_item","depth":5,"payload":{"lines":[10,11],"index":1},"content":"1. <code>.properties</code>"},{"type":"list_item","depth":5,"payload":{"lines":[11,12],"index":2},"content":"2. <code>.yml</code>"}]},{"type":"list_item","depth":4,"payload":{"lines":[12,13],"index":3},"content":"3. how to load: auto load when startup"}]},{"type":"heading","depth":3,"payload":{"lines":[14,15]},"content":"custom config file","children":[{"type":"list_item","depth":4,"payload":{"lines":[16,17],"index":1},"content":"1. location"},{"type":"list_item","depth":4,"payload":{"lines":[17,18],"index":2},"content":"2. format","children":[{"type":"list_item","depth":5,"payload":{"lines":[18,19],"index":1},"content":"1. <code>.properties</code>"},{"type":"list_item","depth":5,"payload":{"lines":[19,20],"index":2},"content":"2. <code>.yml</code>"}]},{"type":"list_item","depth":4,"payload":{"lines":[20,21],"index":3},"content":"3. how to load","children":[{"type":"list_item","depth":5,"payload":{"lines":[21,22],"index":1},"content":"1. <code>@PropertySource</code>: load <code>.properties</code> or <code>.yml</code>"},{"type":"list_item","depth":5,"payload":{"lines":[22,23],"index":2},"content":"2. <code>@ImportResource</code>: load <code>.xml</code>"},{"type":"list_item","depth":5,"payload":{"lines":[23,24],"index":3},"content":"3. <code>@Configuration</code>: <code>configuration class</code>, means config in <code>class</code> not in <code>file</code>"}]}]}]},{"type":"heading","depth":2,"payload":{"lines":[25,26]},"content":"properties injection","children":[{"type":"heading","depth":3,"payload":{"lines":[27,28]},"content":"pre-defined properties","children":[{"type":"list_item","depth":4,"payload":{"lines":[29,30],"index":1},"content":"1. auto inject"}]},{"type":"heading","depth":3,"payload":{"lines":[31,32]},"content":"custom properties","children":[{"type":"list_item","depth":4,"payload":{"lines":[33,34],"index":1},"content":"1. <code>@ConfigurationProperties</code>: batch injection"},{"type":"list_item","depth":4,"payload":{"lines":[34,35],"index":2},"content":"2. <code>@Value</code>: single injection"}]}]}]},{"type":"heading","depth":1,"payload":{"lines":[36,37]},"content":"multi environment","children":[{"type":"list_item","depth":2,"payload":{"lines":[38,39],"index":1},"content":"1. how to config","children":[{"type":"list_item","depth":3,"payload":{"lines":[39,40],"index":1},"content":"1. profile file"},{"type":"list_item","depth":3,"payload":{"lines":[40,41],"index":2},"content":"2. profile annotation"}]},{"type":"list_item","depth":2,"payload":{"lines":[41,42],"index":2},"content":"2. how to activate","children":[{"type":"list_item","depth":3,"payload":{"lines":[42,43],"index":1},"content":"1. <code>spring.profiles.active</code> property in global config file"},{"type":"list_item","depth":3,"payload":{"lines":[43,44],"index":2},"content":"2. <code>spring.profiles.active</code> argument when start application"}]}]},{"type":"heading","depth":1,"payload":{"lines":[45,46]},"content":"misc","children":[{"type":"list_item","depth":2,"payload":{"lines":[47,48],"index":1},"content":"1. random: <code>${random.xxx}</code>"},{"type":"list_item","depth":2,"payload":{"lines":[48,49],"index":2},"content":"2. variable/placeholder: <code>${xxx}</code>"}]}]},{})</script>
</body>
</html>
